<?



interface db_itrfc
{
    public function query($query);
    public function res_query($query);
    public function get_query_info();
}



class simple_db implements db_itrfc
{
    protected $db_host = '';
    protected $db_user = '';
    protected $db_pwd = '';
    protected $db_rsc = null;
    protected $query_info = array();
    
    public $db_messages = array();
    

    public function __construct($host='', $user='', $pwd='')
    {
        $this->db_host = $host;
        $this->db_user = $user;
        $this->db_pwd = $pwd;
        
        $this->db_rsc = @mysql_connect($this->db_host, $this->db_user, $this->db_pwd);
        
        if(!$this->db_rsc)
        {
            $this->db_messages[] = 'Error #'.mysql_errno().': '.mysql_error();

            return false;
        }
        else
        {
            $this->db_messages[] = 'Connect ok';
            
            return true;
        }
    }
    
    public function __destruct()
    {
        return @mysql_close($this->db_rsc);
    }
    
    protected function collect_info()
    {
        $this->query_info['id'] = mysql_insert_id($this->db_rsc);
        $this->query_info['info'] = mysql_info($this->db_rsc);
        
        return;
    }
    
    protected function push_error()
    {
        $this->db_messages[] = 'Error #'.mysql_errno($this->db_rsc).': '.mysql_error($this->db_rsc);
        return false;
    }

    public function query($query)
    {
        $res = null;
        $res = mysql_query($query, $this->db_rsc);
        $this->collect_info();
        
        return $res;
    }
    
    public function res_query($query)
    {
        $result = array();
        $result_query = false;
        $result_query = mysql_query($query, $this->db_rsc);
        $this->collect_info();
        
        if(!$result_query)
        {
            return $this->push_error();
        }
        else
        {
            while($row = mysql_fetch_assoc($result_query))
            {
                $result[] = $row;
            }
        
            return $result;
        }
    }

    public function get_query_info()
    {
        return $this->query_info;
    }
}



function rnd_str($char_num=0)
{
    $abc = str_shuffle('abcdefghijklmnopqrstuvwxyz');
    $res = '';
    
    for($i=0; $i<$char_num; $i++)
    {
        $res .= $abc[rand(0, strlen($abc)-1)]; 
    }
    
    return $res;  
}



class db_utility
{
    protected $db_name = 'ultimacr_api';
    protected $api_table = 'api';
    protected $args_table = 'api_args';
    protected $data_table = 'data';
    protected $basic_queries = array();
    protected $db_handler = null;
    
    public function __construct($db_object)
    {
        $this->db_handler = $db_object;
        $this->create_queries();
    }
    
    protected function create_queries()
    {
        //$this->basic_queries[] = 'DROP DATABASE IF EXISTS `'.$this->db_name.'`';
        //$this->basic_queries[] = 'CREATE DATABASE `'.$this->db_name.'`';
        $this->basic_queries[] = 'USE `'.$this->db_name.'`';
        $this->basic_queries[] = 'DROP TABLE IF EXISTS `'.$this->api_table.'`';
        $this->basic_queries[] = 'CREATE TABLE `'.$this->api_table.'`(' .
                                'id INT not null auto_increment primary key, func_name char(255) binary not null, ' .
                                ' arg_num tinyint not null, ret_type char(255) binary not null)';
        $this->basic_queries[] = 'drop table if exists `'.$this->args_table.'`';
        $this->basic_queries[] = 'create table `'.$this->args_table.'`(' .
                                'id int not null auto_increment primary key, aid int not null, arg_name char(255) binary not null, '.
                                'arg_type char(255) binary not null)';
        $this->basic_queries[] = 'drop table if exists `'.$this->data_table.'`';
        $this->basic_queries[] = 'create table `'.$this->data_table.'`(' .
                                'id int not null auto_increment primary key, f_name char(255) binary not null, '.
                                'l_name char(255) binary not null)';
        
        for($i=0; $i< rand(10, 50); $i++)
        {
            $this->basic_queries[] = 'insert into `'.$this->data_table.'` values (' .
                                    'NULL, "'.rnd_str(rand(3, 10)).'", "'.rnd_str(rand(3, 10)).'")';
        }

        return;
    }
 
    public function run()
    {
        for($i=0; $i<sizeof($this->basic_queries); $i++)
        {
            $this->db_handler->query($this->basic_queries[$i]);
        }

        return;
    }
}


class api
{
    protected $db_name = 'api_test';
    protected $api_table = 'api';
    protected $args_table = 'api_args';
    protected $data_table = 'data';
    protected $api_access = 'api_access';
    protected $api_access_links = 'api_access_links';
    protected $api_users = 'api_users';
    protected $db_handler = null;

    public function __construct($db_object)
    {
        $this->db_handler = $db_object;
        $this->db_handler->query('use `'.$this->db_name.'`');
    }
}


class api_list_utility extends api
{
    protected $basic_queries = array();
    
    public function __construct($db_object)
    {
        parent::__construct($db_object);
        $this->create_functions();
    }
    
    protected function create_functions()
    {
        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_user", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "id", "int")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "delete_user", "1", "bool")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "id", "int")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "add_user", "2", "bool")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "fname", "string")'
                                                    ,'insert into `'.$this->args_table.'` values (NULL, ?, "lname", "string")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "add_users", "1", "bool")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "udata", "array")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_users_or", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "cases", "array")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_users_and", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "cases", "array")'
                                                )
                                    );


        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_users", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "void", "string")'
                                                )
                                    );
        return;
    }
 
    
    public function run()
    {
        $info = array();
        
        for($i=0; $i<sizeof($this->basic_queries); $i++)
        {
            $this->db_handler->query($this->basic_queries[$i]['func']);
            $info = $this->db_handler->get_query_info();

            for($j=0; $j<sizeof($this->basic_queries[$i]['args']); $j++)
            {
                $this->basic_queries[$i]['args'][$j] = str_replace('?', $info['id'], $this->basic_queries[$i]['args'][$j]);
                $this->db_handler->query($this->basic_queries[$i]['args'][$j]);
            }
            
        }

        return;
    }
}


interface api_list_itrfc
{
    public function get_api($func=''); //ret array of all functions or 1 function if get function's name
    public function api_func_exists($func_name='');
    public function chk_args($fname, $args=array());
    //public function chk_ret($fname, $args=array());
}


class api_list extends api implements api_list_itrfc
{ 
    public function __construct($db_object)
    {
        parent::__construct($db_object);
    }

    public function get_api($func='')
    {
        if(isset($func) && !empty($func))
        {
            return $this->get_api_func($func);
        }
        else
        {
            return $this->get_all_api();
        }
    }

    public function api_func_exists($func_name='')
    {
        $array = array();
        $array = $this->get_api($func='');
        
        if(isset($func_name) && is_string($func_name) && !empty($func_name))
        {
            for($i=0; $i<sizeof($array); $i++)
            {
                if($array[$i]['func']['func_name'] == $func_name)
                {
                    return true;
                }
            }
            
            return false;
        }
        else
        {
            return false;
        }
    }

/*
    public function chk_ret($fname, $args=array())
    {
        $fdata = array();
        $adata = array();
        $fdata = $this->get_api_func($fname);
        
    }
*/


    public function chk_args($fname, $args=array())
    {
        $fdata = array();
        $adata = array();
        $fdata = $this->get_api_func($fname);

        if(is_array($args) && is_array($fdata) && isset($fdata[0]['args']) && (sizeof($args) == sizeof($fdata[0]['args'])))
        {
            $adata = $fdata[0]['args'];
            $flag = false;

            for($i=0; $i<sizeof($adata); $i++)
            {
                foreach($args as $key=>$val)
                {
                    if($adata[$i]['arg_name']==$key)
                    {
                        $flag = true;

                        if($this->chk_types($adata[$i]['arg_type'], $val))
                        {
                            break;
                        }
                        else
                        {
                            return false;
                        }
                    }
                }
                
                if(!$flag)
                {
                    return false;
                }
                else
                {
                    $flag = false;
                }
            }
            
            return true;
        }
        else
        {
            return false;
        }
    }

    protected function chk_types($type, $val)
    {
        switch ($type)
        {
            case 'string':
                return is_string($val);
            
            case 'array':
                return is_array($val);
            
            case 'int':
                return is_int($val);
            
            case 'bool':
                return is_bool($val);

            case 'void':
                return (!isset($val) || empty($val)) ?  true : false;
                
            default:
            return false;
        }
    }


    protected function get_all_api()
    {
        $func_data = array();
        $arg_data = array();
        
/*
        $data = $this->db_handler->res_query('SELECT `'.$this->api_table.'`.func_name, `'.$this->api_table.'`.arg_num, `'.$this->api_table.'`.ret_type, `'.$this->args_table.'`.arg_name, `'.$this->args_table.'`.arg_type
                                            FROM `'.$this->api_table.'`, `'.$this->args_table.'`
                                            WHERE `'.$this->api_table.'`.id = `'.$this->args_table.'`.aid
                                            GROUP BY `'.$this->api_table.'`.func_name, `'.$this->args_table.'`.arg_name
                                            ORDER BY `'.$this->api_table.'`.id');
        
*/

        $func_data = $this->db_handler->res_query('SELECT * '.
                                                    'FROM `'.$this->api_table.'`' .
                                                '');

        $arg_data = $this->db_handler->res_query('SELECT * '.
                                                    'FROM `'.$this->args_table.'`' .
                                                '');
                                                
        return $this->api_list_array($func_data, $arg_data);
    }

    protected function get_api_func($func)
    {
        $func_data = array();
        $arg_data = array();

        $func_data = $this->db_handler->res_query('SELECT * '.
                                                  'FROM `'.$this->api_table.'`' .
                                                'WHERE func_name = "'.$func.'"');

        $arg_data = $this->db_handler->res_query('SELECT * '.
                                                    'FROM `'.$this->args_table.'`' .
                                                'WHERE aid = "'.$func_data[0]['id'].'" ');

        return $this->api_list_array($func_data, $arg_data);
    }


    protected function api_list_array($func_data, $arg_data)
    {
        $res = array();

        if((is_array($func_data) && !empty($func_data)) && (is_array($arg_data) && !empty($arg_data)))
        {
            for($i=0; $i<sizeof($func_data); $i++)
            {
                $res[$i]['func'] = array('func_name'=>$func_data[$i]['func_name'] 
                                        ,'arg_num'=>$func_data[$i]['arg_num']
                                        ,'ret_type'=>$func_data[$i]['ret_type']
                                        );
                  
                for($j=0; $j<sizeof($arg_data); $j++)
                {
                    if($func_data[$i]['id'] == $arg_data[$j]['aid'])
                    {
                        $res[$i]['args'][] =  array('arg_name'=>$arg_data[$j]['arg_name'], 'arg_type'=>$arg_data[$j]['arg_type']);
                    }
                }
            }
    
            return $res;
        }
        else
        {
            return false;
        }
    }
}



interface api_functions_itrfc
{
    public function delete_user($id);
    public function add_user($fname, $lname);
    public function add_users($udata);
    public function get_user($id);
    public function get_users();
    public function get_users_and($cases);
    public function get_users_or($cases);
}


class api_functions extends api implements api_functions_itrfc 
{
    public function __construct($db_object)
    {
        parent::__construct($db_object);
    }
    
    public function delete_user($id)
    {
        return $this->db_handler->query('DELETE FROM `'.$this->data_table.'` WHERE id = "'.$id.'"');
    }


    public function add_user($fname, $lname)
    {
        return $this->db_handler->query('INSERT LOW_PRIORITY INTO  `'.$this->data_table.'` values (NULL, "'.$fname.'", "'.$lname.'")');
    }
    
    public function add_users($udata)
    {
        $query = 'INSERT LOW_PRIORITY INTO `'.$this->data_table.'` (id, f_name, l_name) values ';
        
        if(is_array($udata) && !empty($udata))
        {
            for($i=0; $i<sizeof($udata); $i++)
            {
                if($i!=0)
                {
                    $query .= ', '; 
                }

                $query .= '(NULL, "'.$udata[$i]['fname'].'", "'.$udata[$i]['lname'].'" )';
            }
            
            return $this->db_handler->query($query);
        }
        else
        {
            return false;
        }
    }
    
    public function get_user($id)
    {
        return $this->db_handler->res_query('SELECT * FROM `'.$this->data_table.'` WHERE id = '.$id);
    }
    
    public function get_users()
    {
        return $this->db_handler->res_query('SELECT * FROM `'.$this->data_table.'`');
    }
    
    public function get_users_and($cases)
    {
        $query = 'SELECT * FROM `'.$this->data_table.'` WHERE ';
        
        if(is_array($cases) && !empty($cases))
        {
            $j = 0;

            for($i=0; $i<sizeof($cases); $i++)
            {
                foreach($cases[$i] as $key => $val)
                {
                    if($j!=0)
                    {
                        $query .= ' AND ';
                    }
                    
                    $query .= '('.$key.' = "'. $val.'")';
                    
                    $j++;
                }
            }

            return $this->db_handler->res_query($query);
        }
        else
        {
            return false;
        }
    }
    
    public function get_users_or($cases)
    {
        $query = 'SELECT * FROM `'.$this->data_table.'` WHERE ';
        
        if(is_array($cases) && !empty($cases))
        {
            $j = 0;
            
            for($i=0; $i<sizeof($cases); $i++)
            {
                foreach($cases[$i] as $key => $val)
                {
                    if($j!=0)
                    {
                        $query .= ' OR ';
                    }
                    
                    $query .= '('.$key.' = "'. $val.'")';
                    
                    $j++;
                }
            }
            
            return $this->db_handler->res_query($query);
        }
        else
        {
            return false;
        }
    }

}



class api_executor extends api
{
    protected $api_list = null;
    protected $api_functions = null;
    
    public function __construct($db_object)
    {
        parent::__construct($db_object);
        $this->api_list = new api_list($this->db_handler);
        $this->api_functions = new api_functions($this->db_handler);
    }
    
    
    public function execute($func_name, $args=array())
    {
        $res = null;
        
        if($this->api_list->api_func_exists($func_name) && $this->api_list->chk_args($func_name, $args))
        {
            $callback_array = array($this->api_functions, $func_name);

            if(is_callable($callback_array, true, $func_name))
            {
                $res = call_user_func_array($callback_array, $args);
                
                return $res;
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }
}




interface api_gateway_itrfc
{
   public function get_request($str);
}



class api_gateway extends api implements api_gateway_itrfc
{
    protected $api_executor = null;
    protected $response_data = array();
    
    public function __construct($db_object)
    {
        parent::__construct($db_object);
        $this->api_executor = new api_executor($this->db_handler);
    }
    
    public function get_request($str)
    {
        $this->prepare_data($str);
        $this->process_data();
        
        return $this->send_response();
    }

    protected function send_response()
    {
        echo urlencode(serialize($this->response_data));
        return;
    }
    
    protected function prepare_data($str)
    {
        $this->request_data = unserialize(urldecode($str));
        return;
    }
    
    protected function process_data()
    {
        if(is_array($this->request_data) && isset($this->request_data['f_name']) && isset($this->request_data['args']))
        {
            $this->response_data = $this->api_executor->execute($this->request_data['f_name'], $this->request_data['args']);

            return $this->response_data;
        }
        else
        {
            return false;
        }
    }
}









interface api_gateway_smart_itrfc
{
   public function send_response($flag=true, $int=0);
   public function process_data();
}



class api_gateway_smart extends api_gateway implements  api_gateway_itrfc, api_gateway_smart_itrfc
{
    protected $response_data = array();
    protected $request_data = array();
    protected $request_data_format = array();
    
    public function __construct($db_object)
    {
        parent::__construct($db_object);
        
        $this->request_data_format['username'] = '';
        $this->request_data_format['password'] = '';
        $this->request_data_format['f_name'] = '';
        $this->request_data_format['args'] = array();
    }

    public function get_request($str)
    {
        parent::prepare_data($str);
        
        if($this->chk_request())
        {
            return $this->request_data;
        }
        else
        {
            return false;
        }
    }

    public function process_data()
    {
        return parent::process_data();
    }

    public function send_response($bool=true, $int=0)
    {
        if($bool)
        {
            return parent::send_response();
        }
        else
        {
            unset($this->response_data);
            
            switch($int)
            {
                case '1':
                    $this->response_data = array('error'=>'unsupported request format', 'errno'=>1);
                    break; 
                
                case '2':
                    $this->response_data = array('error'=>'autorization failed', 'errno'=>2);
                    break;
                    
                case '3':
                    $this->response_data = array('error'=>'access denied', 'errno'=>3);
                    break;

                default:
                    $this->response_data = array('error'=>'unknown', 'errno'=>0);
                    break;
            }
            
            return parent::send_response();
        }
    }
    
    protected function chk_request()
    {
        $temp = array();
        
        if(is_array($this->request_data))
        {
            foreach($this->request_data_format as $key => $val)
            {
                if(array_key_exists($key, $this->request_data) && (gettype($val)===gettype($this->request_data[$key])))
                {
                    $temp[$key] = $this->request_data[$key];
                }
                else
                {
                    return false;
                }
            }
            
            unset($this->request_data);
            $this->request_data = $temp;
            
            return true;
        }
        else
        {
            return false;
        }
    }
}








class api_access_utility extends api
{
    protected $api_access = 'api_access';
    protected $api_access_links = 'api_access_links';
    protected $api_users = 'api_users';
    protected $basic_queries = array();
    protected $db_handler = null;
    
    public function __construct($db_object)
    {
        parent::__construct($db_object);
        $this->create_queries();
    }
    
    protected function create_queries()
    {
        $this->basic_queries['tables'][] = 'DROP TABLE IF EXISTS `'.$this->api_access.'`';
        $this->basic_queries['tables'][] = 'CREATE TABLE `'.$this->api_access.'`(' .
                                            'id INT not null auto_increment primary key,  ' .
                                            'role_name char(255) binary not null,  access tinyint not null)';


        $this->basic_queries['tables'][] = 'DROP TABLE IF EXISTS `'.$this->api_users.'`';
        $this->basic_queries['tables'][] = 'CREATE TABLE `'.$this->api_users.'`(' .
                                            'id INT not null auto_increment primary key,  ' .
                                            'access tinyint not null,  uname char(255) binary not null, ' .
                                            'pwd char(255) binary not null)';



        $this->basic_queries['tables'][] = 'DROP TABLE IF EXISTS `'.$this->api_access_links.'`';
        $this->basic_queries['tables'][] = 'CREATE TABLE `'.$this->api_access_links.'`(' .
                                            'id INT not null auto_increment primary key,  ' .
                                            'api_id int not null, access_id tinyint not null)';






        $this->basic_queries['access'][] = 'INSERT INTO `'.$this->api_access.'` values (NULL, "select", 1)';
        $this->basic_queries['access'][] = 'INSERT INTO `'.$this->api_access.'` values (NULL, "insert", 2)';
        $this->basic_queries['access'][] = 'INSERT INTO `'.$this->api_access.'` values (NULL, "delete", 4)';


        $this->basic_queries['users'][] = 'INSERT INTO `'.$this->api_users.'` values (NULL, 1, "user1", "'.md5('pwd1').'")';
        $this->basic_queries['users'][] = 'INSERT INTO `'.$this->api_users.'` values (NULL, 1+2, "user2", "'.md5('pwd2').'")';
        $this->basic_queries['users'][] = 'INSERT INTO `'.$this->api_users.'` values (NULL, 1+2+4, "user3", "'.md5('pwd3').'")';


        $this->basic_queries['links'][] = 'INSERT INTO `'.$this->api_access_links.'` values (NULL, "?", "!")';

        return;
    }
 
    public function run()
    {
        $info = array();
        $data = array();
        $data = $this->db_handler->res_query('select * from `'.$this->api_table.'`');

        for($i=0; $i<sizeof($this->basic_queries['tables']); $i++)
        {
            $this->db_handler->query($this->basic_queries['tables'][$i]);
            $info = $this->db_handler->get_query_info();
        }


        for($i=0; $i<sizeof($this->basic_queries['access']); $i++)
        {
            $this->db_handler->query($this->basic_queries['access'][$i]);
            $info = $this->db_handler->get_query_info();

            
            for($j=0; $j<sizeof($data); $j++)
            {
                if((substr_count($data[$j]['func_name'], 'get') && $i==0) ||
                    (substr_count($data[$j]['func_name'], 'add') && $i==1) ||
                    (substr_count($data[$j]['func_name'], 'delete') && $i==2))
                {
                    $query = $this->basic_queries['links'][0];
                    $query = str_replace('!', $info['id'], $query);
                    $query = str_replace('?', $data[$j]['id'], $query);
                    $this->db_handler->query($query);
                
                }
            }
        }
        
        for($i=0; $i<sizeof($this->basic_queries['users']); $i++)
        {
            $this->db_handler->query($this->basic_queries['users'][$i]);
        }

        return;
    }
}







interface api_login_itrfc
{
    public function autorize($username, $password);
}



class api_login extends api implements api_login_itrfc
{
    protected $api_users = 'api_users';
    protected $udata = array();

    public function __construct($db_object)
    {
        parent::__construct($db_object);
    }
    
    public function autorize($username, $password)
    {
        $query = 'select * from `'.$this->api_users.'` where uname = "'.$username.'" and pwd = "'.$this->pwd_hash($password).'"';
        $this->udata = $this->db_handler->res_query($query);
        
        if(isset($this->udata[0]['uname']) && !empty($this->udata[0]['uname']))
        {
            return $this->udata[0];
        }
        else
        {
            return false;
        }
    }
    
    protected function pwd_hash($pwd)
    {
        return md5($pwd);
    }
    
}


interface api_access_itrfc
{
    public function chk_access($access, $f_name);
}



class api_access extends api implements api_access_itrfc
{
    protected $access = 0;
    protected $accessible_api = array();

    public function __construct($db_object)
    {
        parent::__construct($db_object);
    }
    
    public function chk_access($access, $f_name)
    {
        $array = array();
        $flag = true;

        $array = $this->get_access_data();
        
        if(is_array($array) && !empty($array))
        {
            for($i=0; $i<sizeof($array); $i++)
            {
                if(($array[$i]['func_name'] == $f_name) && ($access & $array[$i]['access']))
                {
                    $flag = false;
                    break;
                }
            }
        }
        
        
        if($flag)
        {
            return false;
        }
        else
        {
            return true;
        }
    }

    protected function get_access_data()
    {
        $query = 'SELECT `'.$this->api_access.'`.access, `'.$this->api_access.'`.role_name, `'.$this->api_table.'`.func_name
                    FROM `'.$this->api_access.'`, `'.$this->api_access_links.'`, `'.$this->api_table.'`
                    WHERE `'.$this->api_access.'`.id = `'.$this->api_access_links.'`.access_id
                    AND `'.$this->api_access_links.'`.api_id = `'.$this->api_table.'`.id  ';
        
        
        return $this->db_handler->res_query($query); 
    }

    
}


class api_handler extends api
{
    protected $api_gateway = null;
    protected $api_login = null;
    protected $api_access = null;
    protected $request_data = array();
    protected $user_data = array();
    

    public function __construct($db_object)
    {
        parent::__construct($db_object);
        $this->api_gateway = new api_gateway_smart($this->db_handler);
        $this->api_login = new api_login($this->db_handler);
        $this->api_access = new api_access($this->db_handler);
    }

    public function main($request)
    {
        $this->request_data = $this->api_gateway->get_request($request);

        if($this->request_data)
        {
            $this->user_data = $this->api_login->autorize($this->request_data['username'], $this->request_data['password']);
            
            if($this->user_data)
            {
                if($this->api_access->chk_access($this->user_data['access'], $this->request_data['f_name']))
                {
                    $this->api_gateway->process_data();

                    return $this->api_gateway->send_response();
                }
                else
                {
                    return $this->api_gateway->send_response(false, 3);
                }
            }
            else
            {
                return $this->api_gateway->send_response(false, 2);
            }
        }
        else
        {
            return $this->api_gateway->send_response(false, 1);
        }
    }

}
























